/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** epiwm.h
 ** 
 ** Made by ()
 ** Login   <mulot@epita.fr>
 ** 
 ** Started on  Mon Dec 28 03:19:58 1998 
 ** Last update Tue May 11 13:05:43 1999 mulot
 */

#ifndef   __EPIWM_H__
#define   __EPIWM_H__
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/types.h>
#ifdef	  __Imlib__
#include <Imlib.h>
#endif
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Xproto.h>
#include <X11/keysym.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>

typedef struct	s_win
{
   Window	win;
   Window	parent;
   Window	border_frame;
   Window	button_close;
   Window	button_iconify;
   Window	button_max;
   Window	button_shade;
   Window	button_resize;
   Window	iconify_win;
   Window	icon_choose_win;
   Window	titlebar_win;
   XSizeHints	hints;
   int		win_border;
   int		win_width;
   int		win_height;
   int		win_x;
   int		win_y;
   int		shade_width;
   int		shade_height;
   Bool		is_max;
   Bool		is_shade;
   char		is_max_width;
   char		is_max_height;
   Bool		has_parent;
   char		is_win_shape;
   char		mapped;
   char		state;
   char		active;   
}		t_win;

typedef struct		s_win_list
{
   t_win		*p_t_win;
   struct s_win_list	*next_elt; 
}			t_win_list;

void		help();
void		change_wm();
void		event_type();
void		handle_events();
void		handle_window(Window);
void		options(int , char **);
void		chaos(); 
void		add_border(Window);
void		quit();
t_win		*search_elt(Window);
void		remove_elt(Window);
void		add_elt(t_win *);
void		create_win(Window);
void		add_signals();
void		tab_events();

Atom		EPIWM_WM_STATE;
Atom		EPIWM_WM_CHANGE_STATE;
Atom		EPIWM_WM_PROTOCOLS;
Atom		EPIWM_WM_TAKE_FOCUS;
Atom		EPIWM_WM_DELETE_WINDOW;
Atom		EPIWM_WM_NAME;
Atom		EPIWM_WM_ICON_NAME;
Atom		EPIWM_WM_SAVE_YOURSELF;

#include "window_draw.h"
#include "events.h"
#include "init.h"
#include "key.h"
#include "misc.h"
#include "menu.h"
#include "iconify.h"
#include "mouse_events.h"
#include "screen.h"
#include "workspace.h"
#include "window.h"
#include "window_events.h"
#include "window_state.h"
#include "mouse_functions.h"
#include "icon_styles.h"
#include "window_functions.h"
#include "icon_draw.h"
#include "epiwm_functions.h"
#include "cursor.h"
#endif /* __EPIWM_H__ */
