/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** init.c
 **
 ** Made by ()
 ** Login   <mulot@epita.fr>
 **
 ** Started on  Thu Dec 31 03:18:14 1998
 ** Last update Wed May 26 10:34:07 1999 mulot
 */

#include "epiwm.h"

void	init_misc()
{
  init_tab_function();
  gl_scr_info.screen = DefaultScreen(gl_dpy);
  gl_scr_info.root_win = RootWindow(gl_dpy, gl_scr_info.screen);
  gl_scr_info.dpy_width = DisplayWidth(gl_dpy, gl_scr_info.screen);
  gl_scr_info.dpy_height = DisplayHeight(gl_dpy, gl_scr_info.screen);
  gl_scr_info.depth = DefaultDepth(gl_dpy, gl_scr_info.screen);
  gl_menu.grad_type = 0;
  gl_menu.here_prop = 0;
  gl_menu.here_task = 0;
  gl_menu.font_inactive = XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
  gl_menu.font_active = XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
  gl_menu.width = 0;
  gl_menu_apps = NULL;
  gl_menu.lngst_str = NULL;
  gl_menu.current_elt = NULL;
  gl_menu.current_menu = NULL;
  gl_menu.current_task = NULL;
  gl_menu.auto_menu = 0;
  gl_win_move.win = 0;
  gl_win_move.bef = 0;
  gl_win_move.last = 0;
  gl_icon.font_active =
    XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
  gl_icon.font_inactive =
    XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
  gl_epiwin.titlebar.font_active =
    XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
  gl_epiwin.titlebar.font_inactive =
    XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
  gl_epiwin.titlebar.grad_active_type = 0;
  gl_epiwin.titlebar.grad_inactive_type = 0;
  gl_epiwin.titlebar.position = TOP;
#ifdef	__Imlib__
  gl_menu.image_name = NULL;
  gl_icon.image_active = NULL;
  gl_icon.image_inactive = NULL;
  gl_epiwin.titlebar.image_active = NULL;
  gl_epiwin.titlebar.image_inactive = NULL;
  gl_epiwin.titlebar.image_btn_close = NULL;
  gl_epiwin.titlebar.image_btn_max = NULL;
  gl_epiwin.titlebar.image_btn_resize = NULL;
  gl_epiwin.titlebar.image_btn_shade = NULL;
  gl_epiwin.titlebar.image_btn_iconify = NULL;
  gl_epiwin.titlebar.image_max = 0;
#endif
  gl_epiwin.nb_elt = 0;
  gl_epiwin.btn_width = 12;
  gl_epiwin.btn_height = 12;
  gl_epiwin.titlebar.border = 1;
  gl_epiwin.bf_border = 1;
  gl_epiwin.is_window_changing = 0;
  gl_epiwin.first_win_group_list = NULL;
  gl_epiwin.current = NULL;
  gl_epiwin.is_btn_close = 0;
  gl_epiwin.is_btn_iconify = 0;
  gl_epiwin.is_btn_max = 0;
  gl_epiwin.is_btn_shade = 0;
  gl_epiwin.is_btn_resize = 0;
  gl_epiwin.virtual_width = gl_scr_info.dpy_width * 2;
  gl_epiwin.virtual_height = gl_scr_info.dpy_height * 2;
  gl_epiwin.virtual_x = 0;
  gl_epiwin.virtual_y = 0;
  menu_pos = NULL;
  add_first_workspace();
  add_another_workspace();
  gc_black = XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
  XSetForeground(gl_dpy, gc_black, BlackPixel(gl_dpy,
					      gl_scr_info.screen));
}

/* Capture X-Window errors */
XErrorHandler	handler(gl_dpy, err_event)
     Display		*gl_dpy;
     XErrorEvent	*err_event;
{
  if ((err_event->request_code == X_ChangeWindowAttributes) &&
      (err_event->error_code == BadAccess))
    {
      fprintf(stderr, "Another Window Manager is running...\n");
      change_wm();
      exit (1);
    }
  else
    {
      /*
	fprintf(stderr, "Yeesss, an ERROR : %d %d \n",
	   err_event->error_code,
	   err_event->request_code);
	   */
	return (0);
     }
}

/* just open the display ;) */
void	init_display()
{
  if ((gl_dpy = XOpenDisplay(gl_display_name)) == NULL)
    {
      fprintf(stderr, "\nEPIwm can not open display %s\n\n",
		XDisplayName(gl_display_name));
	help();
	exit (1);
     }
#ifdef	  __Imlib__
   gl_imlib_data = Imlib_init(gl_dpy);
#endif
}
/*
   void		set_font(font, val_font, color)
   XFontStruct	**font;
   char		*val_font;
   GC		*color;
   {
      *font = XLoadQueryFont(gl_dpy, val_font);
      XSetFont(gl_dpy, *color, (*font)->fid);
   }
   */

#ifdef	  __Imlib__
void	init_image(image, state)
     char	*image;
     char	*state;
{
  if (!strcmp(state, "title_active"))
    {
      gl_epiwin.titlebar.image_active = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_epiwin.titlebar.image_active, image);
    }
  else if (!strcmp(state, "title_inactive"))
    {
      gl_epiwin.titlebar.image_inactive = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_epiwin.titlebar.image_inactive, image);
    }
  else if (!strcmp(state, "icon_active"))
    {
      gl_icon.image_active = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_icon.image_active, image);
    }
  else if (!strcmp(state, "icon_inactive"))
    {
      gl_icon.image_inactive = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_icon.image_inactive, image);
    }
  else if (!strcmp(state, "menu"))
    {
      gl_menu.image_name = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_menu.image_name, image);
    }
  else if (!strcmp(state, "btn_close"))
    {
      gl_epiwin.titlebar.image_btn_close = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_epiwin.titlebar.image_btn_close, image);
    }
  else if (!strcmp(state, "btn_max"))
    {
      gl_epiwin.titlebar.image_btn_max = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_epiwin.titlebar.image_btn_max, image);
    }
  else if (!strcmp(state, "btn_resize"))
    {
      gl_epiwin.titlebar.image_btn_resize = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_epiwin.titlebar.image_btn_resize, image);
    }
  else if (!strcmp(state, "btn_shade"))
    {
      gl_epiwin.titlebar.image_btn_shade = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_epiwin.titlebar.image_btn_shade, image);
    }
  else if (!strcmp(state, "btn_iconify"))
    {
      gl_epiwin.titlebar.image_btn_iconify = 
	(char *) malloc(sizeof(char) * (strlen(image) + 1));
      strcpy(gl_epiwin.titlebar.image_btn_iconify, image);
    }
}
#endif

/* Initialization of the colors of fonts */
void		init_font_color(font, color)
     GC		*font;
     char		*color;
{
  XColor	exact_color;
  XColor	tmp_color;
  
  XAllocNamedColor(gl_dpy,
		   XDefaultColormap(gl_dpy, gl_scr_info.screen),
		   color, &tmp_color, &exact_color);
  XSetForeground(gl_dpy, *font, tmp_color.pixel);
}

/* Initialization of the colors of windows */
void		init_color(state, color)
char		*state;
char		*color;
{
   XColor	exact_color;
   
   if (!strcmp("inactive", state))
     XAllocNamedColor(gl_dpy,
		      XDefaultColormap(gl_dpy, gl_scr_info.screen),
		      color, &gl_epiwin.color_inactive, &exact_color);
   else if (!strcmp("active", state))
     XAllocNamedColor(gl_dpy,
		      XDefaultColormap(gl_dpy, gl_scr_info.screen),
		      color, &gl_epiwin.color_active, &exact_color);
   else if (!strcmp("stick", state))
     XAllocNamedColor(gl_dpy,
		      XDefaultColormap(gl_dpy, gl_scr_info.screen),
		      color, &gl_epiwin.color_stick, &exact_color);
   else if (!strcmp("menu_color", state))
     XAllocNamedColor(gl_dpy,
		      XDefaultColormap(gl_dpy, gl_scr_info.screen),
		      color, &gl_menu.color, &exact_color);
   else if (!strcmp("icon_active", state))
     XAllocNamedColor(gl_dpy,
		      XDefaultColormap(gl_dpy, gl_scr_info.screen),
		      color, &gl_icon.color_active, &exact_color);
   else if (!strcmp("icon_inactive", state))
     XAllocNamedColor(gl_dpy,
		      XDefaultColormap(gl_dpy, gl_scr_info.screen),
		      color, &gl_icon.color_inactive, &exact_color);
   else if (!strcmp("title_active", state))
     XAllocNamedColor(gl_dpy,
		      XDefaultColormap(gl_dpy, gl_scr_info.screen),
		      color, &gl_epiwin.titlebar.color_active, &exact_color);
   else if (!strcmp("title_inactive", state))
     XAllocNamedColor(gl_dpy,
		      XDefaultColormap(gl_dpy, gl_scr_info.screen),
		      color, &gl_epiwin.titlebar.color_inactive, &exact_color);
}

/* initialisations of misc GC */
void init_gc()
{
   gc_white = XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
   XSetForeground(gl_dpy, gc_white, WhitePixel(gl_dpy,
					       gl_scr_info.screen));
   gc_light = XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
   XSetForeground(gl_dpy, gc_light, gl_epiwin.color_inactive.pixel);
   gc_dark = XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
   XSetForeground(gl_dpy, gc_dark, gl_epiwin.color_active.pixel);
   gc_medium = XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
   XSetForeground(gl_dpy, gc_medium, gl_epiwin.color_stick.pixel);
   gc_xor = XCreateGC(gl_dpy, gl_scr_info.root_win, 0, NULL);
   XSetSubwindowMode(gl_dpy, gc_xor, IncludeInferiors);
   XSetForeground(gl_dpy, gc_xor, BlackPixel(gl_dpy,
					     gl_scr_info.screen)
		  ^ WhitePixel(gl_dpy, gl_scr_info.screen));
   XSetFunction(gl_dpy, gc_xor, GXxor);
}

/* Select cursors for misc events */
void	init_cursor()
{
   gl_epiwin.iconify_cursor = XCreateFontCursor(gl_dpy, XC_arrow);
   gl_epiwin.normal_cursor = XCreateFontCursor(gl_dpy, XC_left_ptr);
   gl_epiwin.resize_W_cursor = XCreateFontCursor(gl_dpy, XC_left_side);
   gl_epiwin.resize_E_cursor = XCreateFontCursor(gl_dpy, XC_right_side);
   gl_epiwin.resize_N_cursor = XCreateFontCursor(gl_dpy, XC_top_side);
   gl_epiwin.resize_S_cursor = XCreateFontCursor(gl_dpy, XC_bottom_side);
   gl_epiwin.resize_NW_cursor = XCreateFontCursor(gl_dpy, XC_top_left_corner);
   gl_epiwin.resize_NE_cursor = XCreateFontCursor(gl_dpy, XC_top_right_corner);
   gl_epiwin.resize_SW_cursor = XCreateFontCursor(gl_dpy,
						  XC_bottom_left_corner);
   gl_epiwin.resize_SE_cursor = XCreateFontCursor(gl_dpy,
						  XC_bottom_right_corner);
   gl_epiwin.move_cursor = XCreateFontCursor(gl_dpy, XC_fleur);
   XDefineCursor(gl_dpy, gl_scr_info.root_win, gl_epiwin.normal_cursor);
}

/* Select types of evenements to exam */
void			init_event()
{
   XSelectInput(gl_dpy, gl_scr_info.root_win,
		ButtonPressMask | PointerMotionMask |
		SubstructureNotifyMask | ExposureMask | KeyPressMask);
}

/* capture all windows that already exist */
void		capture_windows()
{
   Window	root;
   Window	parent;
   Window	*children;
   unsigned int	nb_children;
   int		i;
   
   XQueryTree(gl_dpy, RootWindow(gl_dpy, gl_scr_info.screen),
	      &root, &parent, &children, &nb_children);
   for (i = 0; i < nb_children; i++)
     handle_window(children[i]);
}

/* initialisation of X */
void	initx()
{
  XSetErrorHandler((XErrorHandler) handler);
  init_gc();
  init_cursor();
  init_event();
  init_atoms();
#ifdef	__Imlib__
  set_titlebar_btn_size();
#endif
  gl_epiwin.titlebar.space = set_title_position();
  capture_windows();
  gl_parent_pid = getpid();
}

char           *cut_str(str, word)
     char           *str;
     char           *word;
{
  while (*str == *word)
    {
      word++;
      str++;
    }
  return (str);
}

char		*index_file(word, word_number)
     char		*word;
     int             word_number;
{
   char		*tokens[1024];
   static char	tmpstring[1024];
   int		i;
   
   i = 0;
   strncpy(tmpstring, word, 1024);
   (char *) tokens[i] = (char *) strtok(tmpstring, " ");
   while (((char *) tokens[++i] = (char *) strtok(NULL, " ")));
   tokens[i] = NULL;
   return (tokens[word_number]);
}

void		init_config(file, part)
FILE           *file;
char           *part;
{
   char	       tmp[250];
   
   if (!strcmp(part, "window"))
     window_build(file);
   else if (!strcmp(part, "start"))
     {
	while (fgets(tmp, 300, file) != NULL)
	  {
	     if (strlen(tmp) != 1)
	       tmp[strlen(tmp) - 1] = ' ';
	     if (!strcasecmp(index_file(tmp, 0), "Init"))
	       system(cut_str(tmp, "Init "));
	  }
     }
   else if (!strcmp(part, "menu"))
     menu_build(file);
   else if (!strcmp(part, "icons"))
     icon_build(file);
   else if (!strcmp(part, "key"))
     key_build(file);
   fclose(file);
}

void	read_config(file)
     char    *file;
{
  char	path[100];
  char home[100];
  FILE *config_file;
  
  strncpy(home, getenv("HOME"), 100);
  sprintf(path, "%s/.epiwm/%s", home, file);
  if ((config_file = fopen(path, "r")) == NULL)
    {
      sprintf(path, "/usr/share/epiwm/%s", file);
      if ((config_file = fopen(path, "r")) == NULL)
	{
	  fprintf(stderr,
		  "Can not open %s/.epiwm/%s or /usr/share/epiwm/%s \n"
		  ,home, file, file);
	  exit (1);
	}
    }
  init_config(config_file, file);
}

void	init_atoms()
{
  gl_epiwin.context = XUniqueContext();
  EPIWM_WM_STATE = XInternAtom(gl_dpy, "WM_STATE", False);
  EPIWM_WM_CHANGE_STATE = XInternAtom(gl_dpy, "WM_CHANGE_STATE", False);
  EPIWM_WM_PROTOCOLS = XInternAtom(gl_dpy, "WM_PROTOCOLS", False);
  EPIWM_WM_TAKE_FOCUS = XInternAtom(gl_dpy, "WM_TAKE_FOCUS", False);
  EPIWM_WM_DELETE_WINDOW = XInternAtom(gl_dpy, "WM_DELETE_WINDOW", False);
  EPIWM_WM_SAVE_YOURSELF = XInternAtom(gl_dpy, "WM_SAVE_YOURSELF", False);    
  EPIWM_WM_NAME = XInternAtom(gl_dpy, "WM_NAME", False);
  EPIWM_WM_ICON_NAME = XInternAtom(gl_dpy, "WM_ICON_NAME", False);   
}
