/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** misc.c
 **
 ** Made by (Julien Mulot)
 ** Login   <mulot@epita.fr>
 **
 ** Started on  Fri Jan  8 21:16:10 1999 Julien Mulot
 ** Last update Sat May  8 22:38:02 1999 Poindessous Thomas
 */

#include "epiwm.h"

void		add_elt(new_win)
t_win		*new_win;
{
   t_win	*tmp;
   t_win_list	*tmp_elt;
   
   tmp = (t_win *) malloc(sizeof(t_win));
   tmp->win = new_win->win;
   tmp->parent = new_win->parent;
   tmp->border_frame = new_win->border_frame;
   if (gl_epiwin.is_btn_resize)
     tmp->button_resize = new_win->button_resize;
   else
     tmp->button_resize = 0;
   if (gl_epiwin.is_btn_max)
     tmp->button_max = new_win->button_max;
   else
     tmp->button_max = 0;
   if (gl_epiwin.is_btn_iconify)
     tmp->button_iconify = new_win->button_iconify;
   else
     tmp->button_iconify = 0;
   tmp->has_parent = new_win->has_parent;
   tmp->titlebar_win = new_win->titlebar_win;
   tmp->is_win_shape = new_win->is_win_shape;
   tmp->hints.width_inc = new_win->hints.width_inc;
   tmp->hints.height_inc = new_win->hints.height_inc;
   tmp->hints.min_width = new_win->hints.min_width;
   tmp->hints.min_height = new_win->hints.min_height;
   tmp->hints.max_width = new_win->hints.max_width;
   tmp->hints.max_height = new_win->hints.max_height;
   tmp->icon_choose_win = 0;
   tmp->iconify_win = 0;
   tmp->is_shade = 0;
   tmp->is_max_width = 0;
   tmp->is_max_height = 0;
   tmp->is_max = 0;
   tmp->mapped = 0;
   tmp->win_border = new_win->win_border;
   tmp_elt = (t_win_list *) malloc(sizeof(t_win_list));
   tmp_elt->p_t_win = tmp;
   tmp_elt->next_elt = NULL;
   if (gl_epiwin.first_win_group_list == NULL)
     {
	gl_epiwin.first_win_group_list = tmp_elt;
	gl_epiwin.nb_elt = 1;
     }
   else
     {
	tmp_elt->next_elt = gl_epiwin.first_win_group_list;
	gl_epiwin.first_win_group_list = tmp_elt;
	gl_epiwin.nb_elt++;
     }
}


t_win		*search_elt(w)
Window          w;
{
   t_win_list	*temp;
   /* t_win_list   *before; */
   
   if (w == 0)
     return (NULL);
   if (gl_epiwin.first_win_group_list)
     {
	temp = gl_epiwin.first_win_group_list;
	/* before = NULL;*/
	while (temp->next_elt && !(search_win(temp->p_t_win, w)))
	  {
	     /*	before = temp;*/
	     temp = temp->next_elt;
	  }
	if (search_win(temp->p_t_win, w))
	  {
	     /*
		if (before)
		{
		before->next_elt = temp->next_elt;
		temp->next_elt = gl_epiwin.first_win_group_list;
		gl_epiwin.first_win_group_list = temp;
		}
		*/
	     return (temp->p_t_win);
	  }
     }
   return (NULL);
}

void		remove_elt(w)
Window		w;
{
   t_win_list	*temp;
   t_win_list   *before;
   
   if (gl_epiwin.first_win_group_list)
     {
	temp = gl_epiwin.first_win_group_list;
	before = NULL;
	while (temp->next_elt && !(search_win(temp->p_t_win, w)))
	  {
	     before = temp;
	     temp = temp->next_elt;
	  }
	if (search_win(temp->p_t_win, w))
	  {
	     if (before)
	       before->next_elt = temp->next_elt;
	     else
	       gl_epiwin.first_win_group_list = temp->next_elt;
	     free(temp->p_t_win);
	     free(temp);
	     gl_epiwin.nb_elt--;
	  }
     }
}


void		change_wm()
{
   char		answer[3];
   int		i;
   char		c;
   
   printf("\nDo you want EPIwm for Window Manager ?(No\\yes) ");
   for (i = 0; i < 3 && (c = getchar()) != '\n'; i++)
     answer[i] = c;
   answer[i] = '\0';
   if (!strncasecmp(answer, "yes", 3))
     {
	system("echo >> ~/.xinitrc");
	printf("\ncopy your xinitrc to xinitrc.old\n");
	system("cp ~/.xinitrc ~/.xinitrc.old");
	printf("add epiwm in your new xinitrc\n");
	system("echo \"exec epiwm\" > ~/.xinitrc");
     }
}

int	search_win(tmp, win)
t_win	*tmp;
Window	win;
{
   return ((tmp->win == win) ||
	   (tmp->parent == win) ||
	   (tmp->button_resize == win) ||
	   (tmp->button_max == win) ||
	   (tmp->button_iconify == win) ||
	   (tmp->iconify_win == win) ||
	   (tmp->titlebar_win == win) ||
	   (tmp->border_frame == win) ||
	   (tmp->icon_choose_win == win));
}
