/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** window_functions.c
 ** 
 ** Made by (Poindessous Thomas)
 ** Login   <poinde_t@epita.fr>
 ** 
 ** Started on  Mon May  3 20:06:30 1999 Poindessous Thomas
 ** Last update Sat May  8 21:05:41 1999 Poindessous Thomas
 */

#include "epiwm.h"

void	win_move(wg_tmp, x, y)
t_win	*wg_tmp;
int	x;
int	y;
{
   XMoveWindow(gl_dpy, wg_tmp->parent, x, y);
   clientSetState(wg_tmp, NormalState);
   send_configure_notify(wg_tmp);
}

void	win_resize(wg_tmp, width, height)
t_win	*wg_tmp;
int	width;
int	height;
{
   gl_event.xresizerequest.window = wg_tmp->win;
   gl_event.xresizerequest.width = width;
   gl_event.xresizerequest.height = height;
   resize_win();
}

void	win_shade(wg_tmp, dummy, dummy2)
t_win	*wg_tmp;
int	dummy;
int	dummy2;
{
   t_mouse_move_win	list;
   XWindowAttributes	attrib;
   
   list.button = &gl_event.xbutton;
   list.temp = wg_tmp;
   list.temp->is_shade = 2;
   if (list.temp->is_max)
     {
	XGetWindowAttributes(gl_dpy, list.temp->parent, &attrib);
	window_group_resize(list.temp, attrib.x, attrib.y,
			    gl_scr_info.dpy_width,
			    gl_epiwin.titlebar.height +
			    2*gl_epiwin.titlebar.border);		  
     }
   else
     {
	XGetWindowAttributes(gl_dpy, list.temp->win, &attrib);
	list.temp->shade_width = attrib.width;
	list.temp->shade_height = attrib.height;
	XGetWindowAttributes(gl_dpy, list.temp->parent, &attrib);
	window_group_resize(list.temp, attrib.x, attrib.y,
			    attrib.width, gl_epiwin.titlebar.height +
			    2*gl_epiwin.titlebar.border);
     }
}

void	win_sendto(wg_tmp, num_workspace, dummy)
t_win	*wg_tmp;
int	num_workspace;
int	dummy;
{
   
}

void	win_quit(wg_tmp, dummy, dummy2)
t_win	*wg_tmp;
int	dummy;
int	dummy2;
{
   clientsendprotocol(wg_tmp, EPIWM_WM_DELETE_WINDOW);
}

void	win_destroy(wg_tmp, dummy, dummy2)
t_win	*wg_tmp;
int	dummy;
int	dummy2;
{
   XKillClient(gl_dpy, wg_tmp->win);
   XFlush(gl_dpy);
}

void			win_iconify(wg_tmp, dummy, dummy2)
t_win			*wg_tmp;
int			dummy;
int			dummy2;
{
   t_mouse_move_win	list;

   list.temp = wg_tmp;
   list.button = malloc(sizeof(XButtonEvent));
   list.button->x = 1 ;
   list.button->y = 1;
   if (wg_tmp->iconify_win == 0)
     mouse_iconify(&list);
   else
     mouse_uniconify(&list);
}







