/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** workspace.h
 ** 
 ** Made by (Poindessous Thomas)
 ** Login   <poinde_t@epita.fr>
 ** 
 ** Started on  Fri Apr  2 15:48:02 1999 Poindessous Thomas
 ** Last update Sun May  9 16:31:35 1999 Poindessous Thomas
 */

#ifndef   __WORKSPACE_H__
#define   __WORKSPACE_H__


typedef struct			s_workspace_window
{
   t_win			*window_group;
   t_icon			*icon;
   Bool				is_win_mapped;
   Bool				is_icon_mapped;
   struct s_workspace_window	*next;
   struct s_workspace_window	*prev;  
}				t_workspace_window;

typedef struct		s_workspace
{
   t_workspace_window	*workspace_window;
   char			nb;
   struct s_workspace	*next;
   struct s_workspace	*prev;
   t_icon_list		*first_icon;
   t_icon_list		*last_icon;
}			t_workspace;

void			workspace_new();
void			workspace_free();
void			workspace_remove(t_workspace *);
t_workspace		*workspace_nth(int);
void			workspace_window_new(t_workspace *, t_win *);
void			workspace_window_free(t_workspace *);
void			workspace_window_remove(t_workspace *,
						t_workspace_window *);
void			add_first_workspace();
void			add_another_workspace();
void			change_current_workspace(t_workspace *);
void			workspace_window_unmap(t_workspace_window *);
void			workspace_window_map(t_workspace_window *);
t_workspace_window	*workspace_window_search(t_workspace *, t_win *);
int			workspace_window_comp(t_workspace_window *, t_win *);
void			send_window_to_workspace(t_win *window, t_workspace *);
t_workspace		*search_window_in_all_workspaces(t_win *);
#endif /* __WORKSPACE_H__ */
